> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Publish a custom payment method type

PUT https://rest.test.zuora.com/open-payment-method-types/publish/{paymentMethodTypeName}

Publish the latest draft revision of a specific custom payment method type.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/payment-methods/custom-payment-method-types/put-publish-open-payment-method-type

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `paymentMethodTypeName` (string, required) — The API name of the custom payment method type, such as `AmazonPay__c_12368`.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

## Response

### 200

OK

- `entityId` (string, optional) — If an entity UUID is provided, this custom payment method type is specific to this entity only. If no entity UUID is provided, the custom payment method type is available to the global entity and all the sub entities in the tenant.
- `fields` (list of OpenPaymentMethodTypeResponseFields, optional) — An array containing field metadata of the custom payment method type.
- `internalName` (string, optional) — A string to identify the custom payment method type in the API name of the payment method type. This field is used along with the `tenantId` field by the system to construct and generate the API name of the custom payment method type in the following way: `<internalName>__c_<tenantId>` For example, if `internalName` is `AmazonPay`, and `tenantId` is `12368`, the API name of the custom payment method type will be `AmazonPay__c_12368`.
- `label` (string, optional) — The label that is used to refer to this type in the Zuora UI.
- `methodReferenceIdField` (string, optional) — The identification reference of the custom payment method. This field should be mapped to a field name defined in the `fields` array for the purpose of being used as a filter in reporting tools such as Payment Method Data Source Exports and Data Query.
- `revision` (integer, optional) — The revision number of the custom payment method type, which starts from 1 and increases by 1 when you update a published revision for the first time.
- `status` (string, optional) — The status of the custom payment method type.
- `subTypeField` (string, optional) — The identification reference indicating the subtype of the custom payment method. This field should be mapped to a field name defined in the `fields` array for the purpose of being used as a filter in reporting tools such as Data Source Exports and Data Query.
- `tenantId` (string, optional) — Zuora tenant ID. If multi-entity is enabled in your tenant, this is the ID of the parent tenant of all the sub entities.
- `userReferenceIdField` (string, optional) — The identification reference of the user or customer account. This field should be mapped to a field name defined in the `fields` array for the purpose of being used as a filter in reporting tools such as Data Source Exports and Data Query.
- `version` (string, optional) — The time when the custom payment method type was first published.

## Types

### OpenPaymentMethodTypeResponseFields

- `checksum` (boolean, optional) — The checksum value of a payment method is used to identify if this payment method is the same as another one, or if this payment method is altered to another new payment method. For example, if you select the credit card number and expiration date as the checksum fields for the CreditCard payment method type, when you modified the expiration date, Zuora considers this payment method as a different payment method compared to the original one.
- `defaultValue` (string, optional) — The default value of the field.
- `description` (string, optional) — An explanation of this field.
- `editable` (boolean, optional) — Specify `true` if this field can be updated through PUT API or UI. Note: If `editable` is set to `false`, you can specify the value of this field in the UI and POST API when creating a payment method. However, after you created the payment method, you cannot edit this field through PUT API or UI.
- `index` (integer, optional) — The order of the field in this type, starting from 1.
- `label` (string, optional) — The label that is used to refer to this field in the Zuora UI.
- `maxLength` (integer, optional) — A maximum length limitation of the field value.
- `minLength` (integer, optional) — A minimal length limitation of the field value.
- `name` (string, optional) — The API name of this field. It must be uinique.
- `representer` (boolean, optional) — This flag determines whether this field will be used for identifying this payment method in the Zuora UI. The field will be shown in the Payment Method field in the UI.
- `required` (boolean, optional) — Specify whether this field is required.
- `type` (enum, optional) — The type of this field.
  - Allowed values: `string`, `date`, `datetime`, `number`, `boolean`
- `visible` (boolean, optional) — Specify `true` if this field can be retrieved through GET API or UI for displaying payment method details. Notes: - If `visible` is set to `false`, you can still specify the value of this field in the UI and POST API when creating the payment method. - If `visible` is set to `false` and `editable` is set to `true`, this field is not accessible through GET API or UI for displaying details, but you can still see it and edit the value in the UI and PUT API when updating this payment method.

## Examples

**Response**

```json
{
  "entityId": "",
  "fields": [
    {
      "checksum": true,
      "description": "The Token value",
      "editable": true,
      "index": 1,
      "label": "AmazonToken",
      "maxLength": 100,
      "minLength": 1,
      "name": "AmazonToken",
      "representer": true,
      "required": true,
      "type": "string",
      "visible": true
    },
    {
      "checksum": true,
      "description": "The Type of Token, e.g. GoCardlessToken",
      "editable": true,
      "index": 2,
      "label": "Amazon TokenType",
      "maxLength": 100,
      "minLength": 1,
      "name": "AmazonTokenType",
      "representer": true,
      "required": true,
      "type": "string",
      "visible": true
    }
  ],
  "internalName": "AmazonPay",
  "label": "ZuoraQA Amazon Pay",
  "methodReferenceIdField": "AmazonToken",
  "revision": 1,
  "status": "Published",
  "subTypeField": "AmazonTokenType",
  "tenantId": "9",
  "userReferenceIdField": "AmazonAccount",
  "version": "2021-11-22"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/open-payment-method-types/publish/paymentMethodTypeName"

headers = {"Authorization": "Bearer <token>"}

response = requests.put(url, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/open-payment-method-types/publish/paymentMethodTypeName';
const options = {method: 'PUT', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/open-payment-method-types/publish/paymentMethodTypeName"

	req, _ := http.NewRequest("PUT", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/open-payment-method-types/publish/paymentMethodTypeName")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://rest.test.zuora.com/open-payment-method-types/publish/paymentMethodTypeName")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://rest.test.zuora.com/open-payment-method-types/publish/paymentMethodTypeName', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/open-payment-method-types/publish/paymentMethodTypeName");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/open-payment-method-types/publish/paymentMethodTypeName")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```